package io.p2vman.pilers;

import org.bukkit.Material;
import org.bukkit.inventory.ItemStack;

import java.util.Random;
import java.util.function.Function;
import java.util.stream.Stream;


public class ItemRandom extends Random {
    public Material nextItem() {
        Material material;
        do {
            material = Material.values()[nextInt(Material.values().length)];
        } while (!material.isItem());
        return material;
    }

    public Material nextBlock() {
        Material material;
        do {
            material = Material.values()[nextInt(Material.values().length)];
        } while (!material.isBlock());
        return material;
    }

    public static final Function<Material, Boolean> BLOCK = Material::isBlock;
    public static final Function<Material, Boolean> ITEM = Material::isItem;
    public static final Function<Material, Boolean> ITEM_BLOCK = (m) -> m.isBlock() | m.isItem();

    public Stream<ItemStack> itemStackStream(int max, int min, Function<Material, Boolean> filter) {
        return Stream.generate(() -> {
            Material material;
            do {
                material = Material.values()[nextInt(Material.values().length)];
            } while (!filter.apply(material));

            return new ItemStack(material, nextInt(min, max));
        });
    }
}
