package io.p2vman.pilers;

import cloud.commandframework.CommandManager;
import cloud.commandframework.execution.CommandExecutionCoordinator;
import cloud.commandframework.paper.PaperCommandManager;

import lombok.AllArgsConstructor;
import lombok.Getter;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.title.TitlePart;

import org.bukkit.*;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.plugin.java.JavaPlugin;

import java.util.*;
import java.util.function.Function;
import java.util.logging.Logger;

public final class Pilers extends JavaPlugin implements Listener {

    public static final Logger LOGGER = Logger.getLogger("Fucked");

    @AllArgsConstructor
    @Getter
    public static class GameState {
        ItemRandom random;
        Builder builder;
        String id;
        boolean start;
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void onPlayerJoin(PlayerJoinEvent event) {
        Player player = event.getPlayer();
        if (state != null && state.start) {
            boolean f = false;
            for (String str : player.getScoreboardTags()) {
                if (Objects.equals(str, "p_"+state.id)) {
                    f = true;
                    break;
                }
            }
            if (!f) {
                player.setGameMode(GameMode.SPECTATOR);
                Iterator<String> tags = player.getScoreboardTags().iterator();
                while (tags.hasNext()) player.removeScoreboardTag(tags.next());
            }
        }
        else {
            player.setGameMode(GameMode.SURVIVAL);
            Iterator<String> tags = player.getScoreboardTags().iterator();
            while (tags.hasNext()) player.removeScoreboardTag(tags.next());
            player.teleport(new Location(Bukkit.getWorlds().get(0), 0, 0, 0));
            Bukkit.getWorlds().get(0).setType(0,-1,0, Material.STONE);
        }
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void onPlayerQuit(PlayerQuitEvent event) {
        update();
    }

    @EventHandler(priority = EventPriority.MONITOR)
    public void onPlayerDeath(PlayerDeathEvent event) {
        Iterator<String> tags = event.getPlayer().getScoreboardTags().iterator();
        while (tags.hasNext()) event.getPlayer().removeScoreboardTag(tags.next());
        event.getPlayer().setGameMode(GameMode.SPECTATOR);
        update();
    }

    public void update() {
        LOGGER.info("update");
        if (state == null || !state.start) {
            LOGGER.info("call");
            return;
        }
        Collection<? extends Player> players = Bukkit.getOnlinePlayers();
        int online = players.size();
        if (online <= 1) {
            stop(Optional.empty());
            LOGGER.info("b");
        }
        else {
            int c = 0;
            Player f = null;
            for (Player player : players) {
                if (player.getGameMode() == GameMode.SURVIVAL && player.getScoreboardTags().contains("p_" + state.id)) {
                    c++;
                    f = player;
                }
            }
            if (c <= 1) {
                LOGGER.info("a");
                stop(Optional.ofNullable(f));
            }
        }
    }

    GameState state = null;

    public void stop(Optional<Player> win) {
        LOGGER.info("stop");
        state.start = false;
        Collection<? extends Player> players = Bukkit.getOnlinePlayers();
        Bukkit.getWorlds().get(0).setType(0,-1,0, Material.STONE);
        Location location = new Location(Bukkit.getWorlds().get(0), 0, 0, 0);
        for (Player player : players) {
            player.setGameMode(GameMode.SURVIVAL);
            Iterator<String> tags = player.getScoreboardTags().iterator();
            while (tags.hasNext()) player.removeScoreboardTag(tags.next());
            player.teleport(location);
            win.ifPresentOrElse((w) -> {
                player.sendTitlePart(TitlePart.TITLE, Component.text("Player ").append(w.displayName()).append(Component.text(" win")));
            }, () -> {
                player.sendTitlePart(TitlePart.TITLE, Component.text("No win"));
            });
        }

        win.ifPresentOrElse((w) -> {
            w.setLevel(1);
        }, () -> {

        });
        state = null;
    }

    @Override
    public void onEnable() {
        getServer().getPluginManager().registerEvents(this, this);
        try {
            CommandManager<CommandSender> manager = new PaperCommandManager<>(this, CommandExecutionCoordinator.simpleCoordinator(), Function.identity(), Function.identity());

            manager.command(manager.commandBuilder("test")
                    .handler((ctx) -> {
                        Builder builder = new Builder();
                        ItemRandom random = new ItemRandom();

                        byte[] buff = new byte[12];
                        random.nextBytes(buff);

                        Collection<? extends Player> players = Bukkit.getOnlinePlayers();
                        state = new GameState(random, builder, Base64.getEncoder().encodeToString(buff), false);

                        builder.build(players.size(), (p) -> {
                            World world = Bukkit.getWorlds().get(0);
                            ctx.getSender().sendMessage("End");
                            List<Player> players_ = new ArrayList<>(Bukkit.getOnlinePlayers());

                            players_.forEach((e) -> {
                                Iterator<String> tags = e.getScoreboardTags().iterator();
                                while (tags.hasNext()) e.removeScoreboardTag(tags.next());
                                e.addScoreboardTag("p_"+state.id);
                                e.setGameMode(GameMode.SURVIVAL);
                            });

                            Iterator<? extends Player> it = players_.iterator();
                            p.forEach((a) -> {
                                int x = (int) (a >> 32);
                                int z = (int) (a & 0xFFFFFFFFL);
                                int y = world.getHighestBlockAt(x, z).getY()+1;
                                if (it.hasNext()) {
                                    it.next().teleport(new Location(world, x, y, z).add(0.5, 0, 0.5));
                                }
                            });

                            state.start = true;

                        }, (c) -> {
                            ctx.getSender().sendMessage(c);
                        });
                    }));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @Override
    public void onDisable() {
        // Plugin shutdown logic
    }
}
